<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 48.10 </title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- daterange picker -->
  <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
  <!-- iCheck for checkboxes and radio inputs -->
  <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
  <!-- Bootstrap Color Picker -->
  <link rel="stylesheet" href="plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- Bootstrap4 Duallistbox -->
  <link rel="stylesheet" href="plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- BS Stepper -->
  <link rel="stylesheet" href="plugins/bs-stepper/css/bs-stepper.min.css">
  <!-- dropzonejs -->
  <link rel="stylesheet" href="plugins/dropzone/min/dropzone.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Quản lý bảng điểm</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->
  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>
    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Thanhlnd</a>
        </div>
      </div>
      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="Task 48.10.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản lý bảng điểm</p>
                </a>
              </li>
            </ul>
          </li>          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>
  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Danh sách Users</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Danh sách Users</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <h2 style="text-align: center;">F200 - LỊCH SỬ HỌC TẬP</h2>
        <div class="container jumbotron py-4">
          <div class="row">
            <h4>Lọc bảng điểm :</h4>
          </div>
          <div class="row">
            <div class="col-12">
              <div class="row">
                <div class="col-5">
                  <div class="row">
                    <div class="col-3">
                      <label for="">Sinh viên</label>
                    </div>
                    <div class="col-7">
                      <select name="" id="select-student" class="form-control"></select>
                    </div>
                  </div>
                </div>
                <div class="col-5">
                  <div class="row">
                    <div class="col-3">
                      <label for="">Môn học</label>
                    </div>
                    <div class="col-7">
                      <select name="" id="select-subject" class="form-control"></select>
                    </div>
                  </div>
                </div>
                <div class="col-2">
                  <button class="btn btn-success" id="btn-filter">Lọc dữ liệu</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="container">
          <div class="row mb-4">
            <button class="btn btn-success" id="btn-add"><i class="fas fa-plus"></i> Thêm mới</button>
          </div>
        </div>
        <div class="container-fluid">
          <table class="table table-bordered table-striped table-dark table-hover" id="table-users">
            <thead>
              <tr>
                <th>STT</th>
                <th>Sinh viên</th>
                <th>Môn học</th>
                <th>Điểm</th>
                <th>Ngày thi</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody>
            </tbody>
          </table>
        </div>
      </div>
      <!-- Modal add detail-->
      <div>
        <div class="modal fade" id="modal-add" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">User detail information</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4">Student Id</label>
                    <div class="col-sm-8">
                      <input type="text" class="form-control" id="inp-studentid">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4">Subject Id</label>
                    <div class="col-sm-8">
                      <input type="text" class="form-control" id="inp-subjectid">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4">Grade</label>
                    <div class="col-sm-8">
                      <input type="text" class="form-control" id="inp-grade">
                    </div>
                  </div>
                  <div class="row form-group">
                    <label class="col-form-label col-sm-4">ExamDate</label>
                    <div class="col-sm-8">
                      <div class="input-group date" id="reservationdate" data-target-input="nearest">
                        <input type="text" id="inp-reservationdate" class="form-control datetimepicker-input" data-target="#reservationdate"/>
                        <div class="input-group-append" data-target="#reservationdate" data-toggle="datetimepicker">
                            <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                        </div>
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer" id="add-btn-create-update">             
              </div>
            </div>
          </div>
        </div>
      </div>
      <div id="delete-modal" class="modal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header text-center">
              <div class="col-12">
                <h5 class="modal-title">DELETE DATA</h5>
              </div>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <div class="col-12 text-center">
                <p>Bạn có chắc muốn xóa dữ liệu không</p>
              </div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-primary btn-confirm-delete">Confirm</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            </div>
          </div>
        </div>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>
</div>
<!-- ./wrapper -->
<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- Select2 -->
<script src="plugins/select2/js/select2.full.min.js"></script>
<!-- Bootstrap4 Duallistbox -->
<script src="plugins/bootstrap4-duallistbox/jquery.bootstrap-duallistbox.min.js"></script>
<!-- InputMask -->
<script src="plugins/moment/moment.min.js"></script>
<script src="plugins/inputmask/jquery.inputmask.min.js"></script>
<!-- date-range-picker -->
<script src="plugins/daterangepicker/daterangepicker.js"></script>
<!-- bootstrap color picker -->
<script src="plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js"></script>
<!-- Tempusdominus Bootstrap 4 -->
<script src="plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
<!-- BS-Stepper -->
<script src="plugins/bs-stepper/js/bs-stepper.min.js"></script>
<!-- dropzonejs -->
<script src="plugins/dropzone/min/dropzone.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
​<script>
  // Biến mảng toàn cục chứa danh sách tên các thuộc tính
  var gARRAY_COL_STUDENTS = ["id","student","subject","grade","date","action"];
  const gARRAY_COL_STT = 0;
  const gARRAY_COL_STUDENT = 1;
  const gARRAY_COL_SUBJECT = 2;
  const gARRAY_COL_GRADE = 3;
  const gARRAY_COL_DATE = 4;
  const gUSER_ACTION_COL = 5;
  gStt = 0;
  var gUserTable = $("#table-users").DataTable({
    columns: [
      { data: gARRAY_COL_STUDENTS[gARRAY_COL_STT] },
      { data: gARRAY_COL_STUDENTS[gARRAY_COL_STUDENT] },
      { data: gARRAY_COL_STUDENTS[gARRAY_COL_SUBJECT] },
      { data: gARRAY_COL_STUDENTS[gARRAY_COL_GRADE] },
      { data: gARRAY_COL_STUDENTS[gARRAY_COL_DATE] },
      { data: gARRAY_COL_STUDENTS[gUSER_ACTION_COL] }
    ],
    columnDefs: [
    {
        targets : gARRAY_COL_STT,
        className : 'text-center',
        render : function(){
          gStt ++;
          return gStt;
        }
      },
      {
        targets: gARRAY_COL_STUDENT,
        className : 'text-center',
      },
      {
        targets: gARRAY_COL_SUBJECT,
        className : 'text-center',
      },
      {
        targets: gARRAY_COL_GRADE,
        className : 'text-center',
      },
      {
        targets: gARRAY_COL_DATE,
        className : 'text-center',
      },
      {
        targets: gUSER_ACTION_COL,
        className : 'text-center',
        defaultContent: '<i class="far fa-edit btn-edit" style="cursor: pointer;color:green"></i> &nbsp; <i class="far fa-trash-alt btn-delete" style="cursor: pointer;color:red"></i>'
      }
    ]
  });
  //Vùng khai báo biến toàn cục
  const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
  gDataStudent = "";
  gDataSubject = "";
  gDataGrade = "";
  var gObjectData = [];
  var gDataRow;
  var gGradeObjRequest = {
    studentId: "",
    subjectId: "",
    grade: "",
    examDate: ""
  };
  $(document).ready(function(){
    onPageLoading()
    $("#btn-filter").click(function(){
      onBtnFilterDataClick()
    })
    console.log(gObjectData)
    //Date picker
    $('#reservationdate').datetimepicker({
        format: 'L'
    });
    $(document).on('click','#btn-add',function(){
      $("#modal-add")
        .find("input,textarea,select")
        .val('')
        .end()
      $("#add-btn-create-update").empty().append(`<button type="button" class="btn btn-success" id="btn-add-modal">ADD</button>
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>`)
      $('#modal-add').modal('show');
    })
    $(document).on('click','#btn-add-modal',function(){
      onBtnAddModalClick();
      
    })
    $(document).on("click",".btn-edit",function(){
      console.log("nút edit đã được ấn");
      $("#add-btn-create-update").empty().append(`<button type="button" class="btn btn-success" id="btn-update-modal">Update</button>
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>`)
      onBtnDetailClick(this);
      $('#modal-add').modal('show');
      onDataToFormModal(gDataRow);
    })
    $(document).on("click",".btn-delete",function(){
      $("#delete-modal").modal("show");
      onBtnDetailClick(this);
    }) 
    $(document).on("click",".btn-confirm-delete", function(){
      deleteUserApi(gDataRow.id);
      gObjectData.length = 0;
      onPageLoading();
    })
    $(document).on("click","#btn-update-modal", function(){
      getDataModalAdd(gGradeObjRequest);
      console.log(gGradeObjRequest);
      var vId = gDataRow.id;
      var vCheck = validateData(gGradeObjRequest);
      if(vCheck == true){
        console.log(gGradeObjRequest);
        onUpdateGradeClick(gGradeObjRequest,vId);
        gObjectData.length = 0;
        console.log(gObjectData)
        onPageLoading();
      }     
    })
    //hàm xử lý nút add trên modal add
    function onBtnAddModalClick(){
      "use strict";
      console.log('Nút add trên modal add được ấn !!!')
      //B1 thu thập dữ liệu
      getDataModalAdd(gGradeObjRequest);  
      var vCheck = validateData(gGradeObjRequest);
      if(vCheck == true){
        console.log(gGradeObjRequest);  
        callApiToCreatData(gGradeObjRequest);
        gObjectData.length = 0;
        onPageLoading();
      }                
  }
    //Hàm load trang
    function onPageLoading(){
      "use strict"
      console.log('Tải trang !!!')
      callApiToGetDataStudent()
      calApiToGetDataSubject()
      calApiToGetDataGrade()
      handleRelationship()
      loadDataToUserTable(gObjectData);
      loadDataToSelectStudent(gDataStudent);
      loadDataToSelectSubject(gDataSubject);
    }
    //hàm xử lý quan hệ n-n các object
    function handleRelationship(){
      "use strict"
      var bI = 0;
        while (bI < gDataGrade.length) {
          var bObject = {'id': gDataGrade[bI].id, 'student': getStudentInfoFromId(gDataGrade[bI].studentId), 'subject': getSubjectInfoFromId(gDataGrade[bI].subjectId), 'grade': gDataGrade[bI].grade, 'date': gDataGrade[bI].examDate};
          gObjectData.push(bObject);  
          bI++;  
        }
    }
    //hàm call api lấy dữ liệu danh sách sinh viên
    function callApiToGetDataStudent(){
      "use strict";
      $.ajax({
        url: gBASE_URL + "/students",
        type: 'GET',
        dataType: 'json', // added data type
        async: false,
        success: function (responseObject) {
          console.log("get data thành công!!!")
          console.log(responseObject)
          gDataStudent = responseObject; 
          // responseObject là array các posts    
        },
        error: function (ajaxContext) {
            alert(ajaxContext.responseText)
        }
      });    
    }
    //hàm call api lấy dữ liệu danh sách môn học
    function calApiToGetDataSubject(){
      "use strict";
      $.ajax({
        url: gBASE_URL + "/subjects",
        type: 'GET',
        dataType: 'json', // added data type
        async: false,
        success: function (responseObject) {
          //console.log(JSON.stringify(responseObject));  //response text
          console.log("get data thành công!!!")
          console.log(responseObject)
          gDataSubject = responseObject; 
          // responseObject là array các posts    
        },
        error: function (ajaxContext) {
            alert(ajaxContext.responseText)
        }
      });    
    }
    // API lấy chi tiết 01 grade by id
    function calApiToGetDataGrade(){
      "use strict";
      $.ajax({
        url: gBASE_URL + "/grades",
        type: 'GET',
        dataType: 'json', // added data type
        async: false,
        success: function (responseObject) {
          //console.log(JSON.stringify(responseObject));  //response text
          console.log("get data thành công!!!")
          console.log(responseObject)
          gDataGrade = responseObject; 
          // responseObject là array các posts    
        },
        error: function (ajaxContext) {
            alert(ajaxContext.responseText)
        }
      });    
    }
    //hàm load dữ liệu vào data table
    function loadDataToUserTable(paramObjectUsers){
      console.log("Hàm load table");
      var vTable = $("#table-users").DataTable();
      vTable.clear();
      vTable.rows.add(paramObjectUsers);
      vTable.draw();
      gStt = 0;
    }
    //Hàm load dữ liệu vào select subject
    function loadDataToSelectSubject(paramSubject){
        "use strict";
        $('#select-subject').append($('<option>', {
              value: "0",
              text: "=== Chọn môn học ==="
          }));
          // Thêm các option từ dữ liệu
          for(var bI = 0; bI < paramSubject.length; bI++){
            $('#select-subject').append($('<option>', {
              value: paramSubject[bI].subjectCode,
              text: paramSubject[bI].subjectName
            }));
          }    
      }
    //hàm load dữ liệu vào select student
    function loadDataToSelectStudent(paramStudentObj){
        "use strict";
        // Thêm option mặc định
        $('#select-student').append($('<option>', {
            value: "0",
            text: "=== Chọn Sinh viên ==="
        }));
        // Thêm các option từ dữ liệu
        for(var bI = 0; bI < paramStudentObj.length; bI++){
          $('#select-student').append($('<option>', {
            value: paramStudentObj[bI].studentCode,
            text: paramStudentObj[bI].firstname + " "+ paramStudentObj[bI].lastname
          }));
        }      
      }
    //Hàm lấy full name stundent
    function getStudentInfoFromId(paramId){
      "use strict"
      var vStudentInfo = "";
      for (var bI= 0; bI< gDataStudent.length; bI++){
          if (gDataStudent[bI].id == paramId){
            vStudentInfo = gDataStudent[bI].firstname + " " + gDataStudent[bI].lastname;
          }
      }
      return vStudentInfo;
    }
    function getSubjectInfoFromId(paramId){
      "use strict"
      var vSubject = "";
      for (var bI= 0; bI< gDataSubject.length; bI++){
          if (gDataSubject[bI].id == paramId){
            vSubject = gDataSubject[bI].subjectName ;
          }
      }
      return vSubject;
    }
     // hàm xử lý sự kiện khi nhấn nút sửa or xóa
     function onBtnDetailClick(paramButtonElement) {
        "use strict";
        var vRowClick = $(paramButtonElement).closest("tr"); // xác định tr chứa nút bấm được click
        var vTable = $("#table-users").DataTable(); // tạo biến truy xuất đến DataTable
        var vDataRow = vTable.row(vRowClick).data(); // Dữ liệu của hàng dữ liệu chứa nút bấm được click
        console.log(vDataRow)
        gDataRow = vDataRow;
    }
    function onDataToFormModal(paramData){
      $('#inp-studentid').val(paramData.student);
      $('#inp-subjectid').val(paramData.subject);
      $('#inp-grade').val(paramData.grade);
      $('#inp-reservationdate').val(paramData.date);
    }

    //hàm xử lý filter
    function onBtnFilterDataClick(){
      console.log("filter đã được chạy")
      console.log(gObjectData)
      var vFilterStudent = $("#select-student").val();
      var vFilterSubjet = $("#select-subject").val();
      var vFilterStudentText = $("#select-student :selected").text();
      var vFilterSubjetText = $("#select-subject :selected").text();
      var vDataFilter = gObjectData.filter(function(item){
        return(vFilterStudent == "0"|| item.student == vFilterStudentText)&&(vFilterSubjet == "0" || item.subject == vFilterSubjetText)
      })
      loadDataToUserTable(vDataFilter);
    }
    //call api để tạo grade mới
    function callApiToCreatData(paramObject){
      "use strict"
      $.ajax({
          url: gBASE_URL + "grades",
          type: 'POST',
          data: JSON.stringify(paramObject), // added data type
          contentType:"application/json",
          async: false,
          success: function (responseObject) {
            console.log(JSON.stringify(responseObject));  //response text
            alert("thêm dữ liệu thành công " + JSON.stringify(responseObject))   
            $('#modal-add').modal('hide');
          },
          error: function (ajaxContext) {
              alert(ajaxContext.responseText)
          }
        }); 
    }
    //hàm xóa dữ liệu
    function deleteUserApi(paramUserId){
      "use strict";
      $.ajax ({
        async: false,
        url: gBASE_URL +  "/grades/"  + paramUserId,
        type: "DELETE",
        data: 'json',
        success: function(res){
          alert("xóa dữ liệu thành công " );
          $("#delete-modal").modal("hide");
        },
        error: function(error){
            alert(error.responseText);
        }
      })
    }
     //call api để update dữ liệu
     function onUpdateGradeClick(paramObject,paramId){
      "use strict"
      $.ajax({
          url: gBASE_URL + "/grades" + "/" + paramId,
          type: 'PUT',
          data: JSON.stringify(paramObject), // added data type
          contentType:"application/json",
          async: false,
          success: function (responseObject) {
            alert("update dữ liệu thành công " + JSON.stringify(responseObject))
            $('#modal-add').modal('hide');
          },
          error: function (ajaxContext) {
              alert(ajaxContext.responseText)
          }
        }); 
    }
    //hàm thu thập dữ liệu trên modal add
    function getDataModalAdd(paramData){
      "use strict";
      paramData.studentId = $('#inp-studentid').val();
      paramData.subjectId = $('#inp-subjectid').val();
      paramData.grade = $('#inp-grade').val();
      paramData.examDate = $('#inp-reservationdate').val();
    }
    //hàm validate dữ liệu
    function validateData(paramData){
    "use strict";
    if(paramData.studentId == ''){
      alert('Không được để trống Student ID !!!')
      return false
    }
    if(paramData.subjectId == ''){
      alert('Không được để trống Subject ID !!!')
      return false
    }
    if(paramData.grade == ''){
      alert('Không được để trống Grade !!!')
      return false
    }
    if(paramData.examDate == ''){
      alert('Không được để trống Exam Date !!!')
      return false
    }
    return true
  } 
})
</script>
</body>
</html>
